# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sbg_driver/SbgAirDataStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SbgAirDataStatus(genpy.Message):
  _md5sum = "7a096a0984e0fe096308cfb42a254e4a"
  _type = "sbg_driver/SbgAirDataStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# SBG Ellipse Messages
# Submessage

# True if the time stamp field represents a delay instead of an absolute time stamp.
bool is_delay_time

# True if the pressure field is filled and valid.
bool pressure_valid

# True if the barometric altitude field is filled and valid.
bool altitude_valid

# True if the differential pressure field is filled and valid.
bool pressure_diff_valid

# True if the true airspeed field is filled and valid.
bool air_speed_valid

# True if the output air temperature field is filled and valid.
bool air_temperature_valid"""
  __slots__ = ['is_delay_time','pressure_valid','altitude_valid','pressure_diff_valid','air_speed_valid','air_temperature_valid']
  _slot_types = ['bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       is_delay_time,pressure_valid,altitude_valid,pressure_diff_valid,air_speed_valid,air_temperature_valid

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SbgAirDataStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.is_delay_time is None:
        self.is_delay_time = False
      if self.pressure_valid is None:
        self.pressure_valid = False
      if self.altitude_valid is None:
        self.altitude_valid = False
      if self.pressure_diff_valid is None:
        self.pressure_diff_valid = False
      if self.air_speed_valid is None:
        self.air_speed_valid = False
      if self.air_temperature_valid is None:
        self.air_temperature_valid = False
    else:
      self.is_delay_time = False
      self.pressure_valid = False
      self.altitude_valid = False
      self.pressure_diff_valid = False
      self.air_speed_valid = False
      self.air_temperature_valid = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_6B().pack(_x.is_delay_time, _x.pressure_valid, _x.altitude_valid, _x.pressure_diff_valid, _x.air_speed_valid, _x.air_temperature_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.is_delay_time, _x.pressure_valid, _x.altitude_valid, _x.pressure_diff_valid, _x.air_speed_valid, _x.air_temperature_valid,) = _get_struct_6B().unpack(str[start:end])
      self.is_delay_time = bool(self.is_delay_time)
      self.pressure_valid = bool(self.pressure_valid)
      self.altitude_valid = bool(self.altitude_valid)
      self.pressure_diff_valid = bool(self.pressure_diff_valid)
      self.air_speed_valid = bool(self.air_speed_valid)
      self.air_temperature_valid = bool(self.air_temperature_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_6B().pack(_x.is_delay_time, _x.pressure_valid, _x.altitude_valid, _x.pressure_diff_valid, _x.air_speed_valid, _x.air_temperature_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.is_delay_time, _x.pressure_valid, _x.altitude_valid, _x.pressure_diff_valid, _x.air_speed_valid, _x.air_temperature_valid,) = _get_struct_6B().unpack(str[start:end])
      self.is_delay_time = bool(self.is_delay_time)
      self.pressure_valid = bool(self.pressure_valid)
      self.altitude_valid = bool(self.altitude_valid)
      self.pressure_diff_valid = bool(self.pressure_diff_valid)
      self.air_speed_valid = bool(self.air_speed_valid)
      self.air_temperature_valid = bool(self.air_temperature_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_6B = None
def _get_struct_6B():
    global _struct_6B
    if _struct_6B is None:
        _struct_6B = struct.Struct("<6B")
    return _struct_6B
